import es
import gamethread
import langlib
import playerlib
import popuplib
import random
from spe.games import cstrike

def load():
	create_popup()

	es.load("soccer_mod_2010/cap/fights")

def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/popup_admin_cap.ini")

	popup = popuplib.create("sm_popup_admin_cap")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	line = "->1. %s" % (text("spectator"))
	popup.addline(line)

	line = "->2. %s" % (text("fights"))
	popup.addline(line)

	line = "->3. %s" % (text("random_caps"))
	popup.addline(line)

	line = "->4. %s" % (text("random_teams"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, spec_all)
	popup.select(2, cap_fights)
	popup.select(3, random_caps)
	popup.select(4, random_teams)
	popup.submenu(5, "sm_popup_admin_cap")
	popup.submenu(6, "sm_popup_admin_cap")
	popup.submenu(7, "sm_popup_admin_cap")
	popup.submenu(8, "sm_popup_admin_cap")
	popup.submenu(9, "sm_popup_admin")

def spec_all(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		check = es.ServerVar("cap_fight")
		if check == 0:
			players = es.getUseridList()
			for player in players:
				name = es.getplayername(player)
				es.changeteam(player, 1)

			message = "Cap match will start soon."
			myPlayerList = playerlib.getPlayerList("#human")
			for ply in myPlayerList:
				cmd = 'usermsg hudhint %s "%s"' % (ply.userid, message)
				es.server.queuecmd(cmd)

			es.centermsg(message)

			name = es.getplayername(userid)
			message = "%s has put all players to spectator." % (name)
			es.msg("#green", message)
		else:
			es.tell(userid, "#green", "You can not put all players to spectator during a cap fight.")
	else:
		es.tell(userid, "#green", "You can not put all players to spectator during a match.")

	popuplib.send("sm_popup_admin_cap", userid)

def cap_fights(userid, choice, popupid):
	popuplib.send("sm_popup_admin_cap_fights", userid)

def random_caps(userid, choice, popupid):
	check = es.ServerVar("cap_fight")
	if check == 0:
		check = es.ServerVar("match")
		if check == 0:
			name = es.getplayername(userid)
			message = "%s has forced random caps." % (name)
			force_caps(userid)
		else:
			es.tell(userid, "#green", "You can not force random caps during a match.")
	else:
		es.tell(userid, "#green", "You can not force random caps during a cap fight.")

	popuplib.send("sm_popup_admin_cap", userid)

def force_caps(userid):
	myPlayerList = playerlib.getPlayerList("#spec,#human")

	length = len(myPlayerList)
	if length > 0:
		length -= 1
		if length > 0:
			number = random.randint(0, length)
		else:
			number = 0

		es.changeteam(myPlayerList[number], 2)

		cstrike.respawn(myPlayerList[number])

		name = es.getplayername(myPlayerList[number])
		message = "%s has been selected as cap for the terrorists." % (name)
		es.msg("#green", message)
	else:
		es.tell(userid, "#green", "No spectator available to select as cap for the terrorists.")

	myPlayerList = playerlib.getPlayerList("#spec,#human")

	length = len(myPlayerList)
	if length > 0:
		length -= 1
		if length > 0:
			number = random.randint(0, length)
		else:
			number = 0

		es.changeteam(myPlayerList[number], 3)

		cstrike.respawn(myPlayerList[number])

		name = es.getplayername(myPlayerList[number])
		message = "%s has been selected as cap for the counter-terrorists." % (name)
		es.msg("#green", message)
	else:
		es.tell(userid, "#green", "No spectator available to select as cap for the counter-terrorists.")

def random_teams(userid, choice, popupid):
	check = es.ServerVar("cap_fight")
	if check == 0:
		check = es.ServerVar("match")
		if check == 0:
			name = es.getplayername(userid)
			message = "%s has forced random teams." % (name)
			force_teams(userid)
		else:
			es.tell(userid, "#green", "You can not force random teams during a match.")
	else:
		es.tell(userid, "#green", "You can not force random teams during a cap fight.")

	popuplib.send("sm_popup_admin_cap", userid)

def force_teams(userid):
	myPlayerList = playerlib.getPlayerList("#spec,#human")

	players = len(myPlayerList)
	if players > 0:
		if players > 12:
			players = 12

		count = 1
		team = 2
		while count <= players:
			myPlayerList = playerlib.getPlayerList("#spec,#human")
			length = len(myPlayerList)

			if length > 1:
				number = random.randint(0, (length - 1))
			else:
				number = 0

			es.changeteam(myPlayerList[number], team)

			cstrike.respawn(myPlayerList[number])

			if team == 2:
				team_name = "terrorists"
			elif team == 3:
				team_name = "counter-terrorists"

			name = es.getplayername(myPlayerList[number])
			message = "%s has been selected as player for the %s." % (name, team_name)
			es.msg("#green", message)

			team += 1
			if team > 3:
				team = 2
			
			count += 1
	else:
		es.tell(userid, "#green", "No spectators available to select as player.")

def delete_popup():
	if popuplib.exists("sm_popup_admin_cap"):
		popuplib.delete("sm_popup_admin_cap")

def unload():
	delete_popup()
	es.unload("soccer_mod_2010/cap/fights")