import es
import gamethread
import keymenulib
import langlib
import playerlib
import popuplib

def load():
	create_popup()

	enabled = es.ServerVar("sm_module_referee_punish_on")
	if enabled == 1:
		es.load("soccer_mod_2010/referee/punish")

	enabled = es.ServerVar("sm_module_referee_warn_on")
	if enabled == 1:
		es.load("soccer_mod_2010/referee/warn")

def es_map_start(event_var):
	delete_keygroup_yellow()
	delete_keygroup_red()

def player_spawn(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		steamid = es.getplayersteamid(event_var["userid"])
		exists = es.exists("key", "soccer_mod_red_card", steamid)
		if exists == 1:
			es.changeteam(event_var["userid"], 1)

def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/referee/popup_admin_referee.ini")

	popup = popuplib.create("sm_popup_admin_referee")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	number = 1

	enabled = es.ServerVar("sm_module_referee_warn_on")
	if enabled == 1:
		line = "->%s. %s" % (number, text("warn"))
		popup.addline(line)
		popup.submenu(number, "sm_popup_admin_referee_warn")
		number += 1

	line = "->%s. %s" % (number, text("yellow"))
	popup.addline(line)
	popup.select(number, yellow)
	number += 1

	line = "->%s. %s" % (number, text("red"))
	popup.addline(line)
	popup.select(number, red)
	number += 1

	line = "->%s. %s" % (number, text("clear"))
	popup.addline(line)
	popup.select(number, clear_cards)
	number += 1

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	while number < 9:
		popup.submenu(number, "sm_popup_admin_referee")
		number += 1

	popup.submenu(9, "sm_popup_admin")

def yellow(userid, choice, popupid):
	name = "sm_keymenu_%s" % (userid)
	if keymenulib.exists(name):
		keymenulib.delete(name)

	source_tv = es.ServerVar("tv_name")

	es.keygroupcreate("playerlist")

	myPlayerList = playerlib.getPlayerList("#all")
	for ply in myPlayerList:
		if ply.name != source_tv:
			es.keycreate("playerlist", ply.userid)
			es.keysetvalue("playerlist", ply.userid, "username", ply.name)

	keymenu = keymenulib.create(name, "target", yellow_choice, "playerlist", "#keyvalue username", "#key", "Select a player")
	keymenu.backmenu("sm_popup_admin_referee")
	keymenulib.send(name, userid)

	es.keygroupdelete("playerlist")

def yellow_choice(userid, choice, keymenuname):
	steamid = es.getplayersteamid(choice)

	exists = es.exists("key", "soccer_mod_red_card", steamid)
	if exists == 0:
		exists = es.exists("keygroup", "soccer_mod_yellow_card")
		if exists == 0:
			es.keygroupcreate("soccer_mod_yellow_card")

		exists = es.exists("key", "soccer_mod_yellow_card", steamid)
		if exists == 0:
			es.keycreate("soccer_mod_yellow_card", steamid)
		else:
			exists = es.exists("keygroup", "soccer_mod_red_card")
			if exists == 0:
				es.keygroupcreate("soccer_mod_red_card")

			es.keycreate("soccer_mod_red_card", steamid)

		name = es.getplayername(userid)
		target = es.getplayername(choice)

		exists = es.exists("key", "soccer_mod_red_card", steamid)
		if exists == 0:
			sound = es.ServerVar("sm_referee_sound_whistle")
			es.cexec_all("playgamesound", sound)

			message = "%s has given a yellow card to %s." % (name, target)
			es.msg("#green", message)
		else:
			sound = es.ServerVar("sm_referee_sound_whistle")
			play_sound(sound)
			sound = es.ServerVar("sm_referee_sound_red_card")
			gamethread.delayed(0.5, play_sound, (sound))

			gamethread.delayed(6, change_team, (choice))

			message = "%s has given a second yellow card to %s." % (name, target)
			es.msg("#green", message)
	else:
		es.tell(userid, "#green", "This player already has a red card.")

	popuplib.send("sm_popup_admin_referee", userid)

def red(userid, choice, popupid):
	name = "sm_keymenu_%s" % (userid)
	if keymenulib.exists(name):
		keymenulib.delete(name)

	source_tv = es.ServerVar("tv_name")

	es.keygroupcreate("playerlist")

	myPlayerList = playerlib.getPlayerList("#all")
	for ply in myPlayerList:
		if ply.name != source_tv:
			es.keycreate("playerlist", ply.userid)
			es.keysetvalue("playerlist", ply.userid, "username", ply.name)

	keymenu = keymenulib.create(name, "target", red_choice, "playerlist", "#keyvalue username", "#key", "Select a player")
	keymenu.backmenu("sm_popup_admin_referee")
	keymenulib.send(name, userid)

	es.keygroupdelete("playerlist")

def red_choice(userid, choice, popupid):
	steamid = es.getplayersteamid(choice)

	exists = es.exists("key", "soccer_mod_red_card", steamid)
	if exists == 0:
		exists = es.exists("keygroup", "soccer_mod_red_card")
		if exists == 0:
			es.keygroupcreate("soccer_mod_red_card")

		es.keycreate("soccer_mod_red_card", steamid)

		sound = es.ServerVar("sm_referee_sound_whistle")
		play_sound(sound)
		sound = es.ServerVar("sm_referee_sound_red_card")
		gamethread.delayed(0.5, play_sound, (sound))

		gamethread.delayed(6, change_team, (choice))

		name = es.getplayername(userid)
		target = es.getplayername(choice)

		name = es.getplayername(userid)
		message = "%s has given a red card to %s." % (name, target)
		es.msg("#green", message)
	else:
		es.tell(userid, "#green", "This player already has a red card.")

	popuplib.send("sm_popup_admin_referee", userid)

def play_sound(sound):
	es.cexec_all("playgamesound", sound)

def change_team(userid):
	es.changeteam(userid, 1)

def clear_cards(userid, choice, popupid):
	delete_keygroup_yellow()
	delete_keygroup_red()

	name = es.getplayername(userid)
	message = "%s has cleared all cards." % (name)
	es.msg("#green", message)

	popuplib.send("sm_popup_admin_referee", userid)

def delete_keygroup_yellow():
	exists = es.exists("keygroup", "soccer_mod_yellow_card")
	if exists == 1:
		es.keygroupdelete("soccer_mod_yellow_card")

def delete_keygroup_red():
	exists = es.exists("keygroup", "soccer_mod_red_card")
	if exists == 1:
		es.keygroupdelete("soccer_mod_red_card")

def delete_popup():
	if popuplib.exists("sm_popup_admin_referee"):
		popuplib.delete("sm_popup_admin_referee")

def unload():
	delete_keygroup_yellow()
	delete_keygroup_red()
	delete_popup()

	enabled = es.ServerVar("sm_module_referee_punish_on")
	if enabled == 1:
		es.unload("soccer_mod_2010/referee/punish")

	enabled = es.ServerVar("sm_module_referee_warn_on")
	if enabled == 1:
		es.unload("soccer_mod_2010/referee/warn")