import es
import langlib
import popuplib

popup = popuplib.create("sm_popup_admin_settings_player")
text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_player.ini")

def load():
	load_settings()
	create_popup()

def load_settings():
	value = int(es.keygetvalue("soccer_mod_settings", "player", "god_mode"))
	es.set("sm_player_god_mode_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "player", "hurt_sounds"))
	es.set("sm_player_hurt_sounds_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "player", "skins"))
	es.set("sm_player_skins_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "player", "respawn_length"))
	es.set("sm_player_respawn_length", value)

def create_popup():
	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	value = es.ServerVar("sm_player_god_mode_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->1. %s: %s" % (text("god mode"), value)
	popup.addline(line)

	value = es.ServerVar("sm_player_hurt_sounds_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->2. %s: %s" % (text("hurt sounds"), value)
	popup.addline(line)

	value = es.ServerVar("sm_player_skins_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->3. %s: %s" % (text("skins"), value)
	popup.addline(line)

	value = es.ServerVar("sm_player_respawn_length")
	line = "->4. %s: %s" % (text("respawn length"), value)
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, god_mode)
	popup.select(2, hurt_sounds)
	popup.select(3, skins)
	popup.select(4, respawn_length)
	popup.submenu(5, "sm_popup_admin_settings_player")
	popup.submenu(6, "sm_popup_admin_settings_player")
	popup.submenu(7, "sm_popup_admin_settings_player")
	popup.submenu(8, "sm_popup_admin_settings_player")
	popup.submenu(9, "sm_popup_admin_settings")

def god_mode(userid, choice, popupid):
	name = es.getplayername(userid)
	value = es.ServerVar("sm_player_god_mode_on")
	if value == 1:
		es.set("sm_player_god_mode_on", 0)
		es.keysetvalue("soccer_mod_settings", "player", "god_mode", 0)

		line = "->1. %s: %s" % (text("god mode"), text("off"))
		popup.modline(3, line)

		message = "%s has turned god mode off." % (name)
	else:
		es.set("sm_player_god_mode_on", 1)
		es.keysetvalue("soccer_mod_settings", "player", "god_mode", 1)

		line = "->1. %s: %s" % (text("god mode"), text("on"))
		popup.modline(3, line)

		message = "%s has turned god mode on." % (name)

	es.msg("#green", message)

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_player", userid)

def hurt_sounds(userid, choice, popupid):
	name = es.getplayername(userid)
	value = es.ServerVar("sm_player_hurt_sounds_on")
	if value == 1:
		es.set("sm_player_hurt_sounds_on", 0)
		es.keysetvalue("soccer_mod_settings", "player", "hurt_sounds", 0)

		line = "->2. %s: %s" % (text("hurt sounds"), text("off"))
		popup.modline(4, line)

		message = "%s has turned hurt sounds off." % (name)
	else:
		es.set("sm_player_hurt_sounds_on", 1)
		es.keysetvalue("soccer_mod_settings", "player", "hurt_sounds", 1)

		line = "->2. %s: %s" % (text("hurt sounds"), text("on"))
		popup.modline(4, line)

		message = "%s has turned hurt sounds on." % (name)

	es.msg("#green", message)

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_player", userid)

def skins(userid, choice, popupid):
	name = es.getplayername(userid)
	value = es.ServerVar("sm_player_skins_on")
	if value == 1:
		es.set("sm_player_skins_on", 0)
		es.keysetvalue("soccer_mod_settings", "player", "skins", 0)

		line = "->3. %s: %s" % (text("skins"), text("off"))
		popup.modline(5, line)

		message = "%s has turned skins off." % (name)
	else:
		es.set("sm_player_skins_on", 1)
		es.keysetvalue("soccer_mod_settings", "player", "skins", 1)

		line = "->3. %s: %s" % (text("skins"), text("on"))
		popup.modline(5, line)

		message = "%s has turned skins on." % (name)

	es.msg("#green", message)

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_player", userid)

def respawn_length(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_player_respawn_length")

	es.tell(userid, "#green", "Type a value between 1 and 60 in the chat to set the respawn length or type !cancel to cancel.")

def no_choice(userid, choice, popupid):
	popuplib.send("sm_popup_admin_settings_player", userid)

def back(userid, choice, popupid):
	popuplib.send("sm_popup_admin_settings", userid)

def player_say(event_var):
	steamid = es.getplayersteamid(event_var["userid"])

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "settings_player_respawn_length":
			if event_var["text"] != "!cancel":
				error = "Type a value between 1 and 60 in the chat to set the respawn length or type !cancel to cancel."
				try:
					temp_value = float(event_var["text"])
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 60:
							es.set("sm_player_respawn_length", value)

							line = "->4. %s: %s" % (text("respawn length"), value)
							popup.modline(6, line)

							es.keysetvalue("soccer_mod_settings", "player", "respawn_length", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(event_var["userid"])
							message = "%s has set the number of respawn length to %s." % (name, value)
							es.msg("#green", message)

							clear_key(event_var["userid"], steamid)
						else:
							es.tell(event_var["userid"], "#green", error)
					else:
						es.tell(event_var["userid"], "#green", error)
				except ValueError:
					es.tell(event_var["userid"], "#green", error)
			else:
				clear_key(event_var["userid"], steamid)

def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_settings_player", userid)

def delete_popup():
	if popuplib.exists("sm_popup_admin_settings_player"):
		popuplib.delete("sm_popup_admin_settings_player")

def unload():
	delete_popup()