import es
import langlib
import popuplib

popup = popuplib.create("sm_popup_admin_settings_sprint")
text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_sprint.ini")

def load():
	load_settings()
	create_popup()

def load_settings():
	value = float(es.keygetvalue("soccer_mod_settings", "sprint", "speed"))
	es.set("sm_sprint_speed", value)

	value = int(es.keygetvalue("soccer_mod_settings", "sprint", "length"))
	es.set("sm_sprint_length", value)

	value = int(es.keygetvalue("soccer_mod_settings", "sprint", "reset"))
	es.set("sm_sprint_reset", value)

def create_popup():
	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	value = es.ServerVar("sm_sprint_speed")
	line = "->1. %s: %s" % (text("speed"), value)
	popup.addline(line)

	value = es.ServerVar("sm_sprint_length")
	line = "->2. %s: %s" % (text("length"), value)
	popup.addline(line)

	value = es.ServerVar("sm_sprint_reset")
	line = "->3. %s: %s" % (text("reset"), value)
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, speed)
	popup.select(2, length)
	popup.select(3, reset)
	popup.submenu(4, "sm_popup_admin_settings_sprint")
	popup.submenu(5, "sm_popup_admin_settings_sprint")
	popup.submenu(6, "sm_popup_admin_settings_sprint")
	popup.submenu(7, "sm_popup_admin_settings_sprint")
	popup.submenu(8, "sm_popup_admin_settings_sprint")
	popup.submenu(9, "sm_popup_admin_settings")

def speed(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_sprint_speed")


	es.tell(userid, "#green", "Type a value between 1 and 10 in the chat to set the sprint speed or type !cancel to cancel.")

def length(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_sprint_length")

	es.tell(userid, "#green", "Type a value between 1 and 10 in the chat to set the sprint length or type !cancel to cancel.")

def reset(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_sprint_reset")

	es.tell(userid, "#green", "Type a value between 1 and 100 in the chat to set the sprint reset length or type !cancel to cancel.")

def player_say(event_var):
	steamid = es.getplayersteamid(event_var["userid"])

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "settings_sprint_speed":
			if event_var["text"] != "!cancel":
				error = "Type a value between 1 and 10 in the chat to set the sprint speed or type !cancel to cancel."
				try:
					temp_value = float(event_var["text"])
					value = round(temp_value, 2)
					if value >= 1:
						if value <= 10:
							es.set("sm_sprint_speed", value)

							line = "->1. %s: %s" % (text("speed"), value)
							popup.modline(3, line)

							es.keysetvalue("soccer_mod_settings", "sprint", "speed", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(event_var["userid"])
							message = "%s has set the sprint speed to %s." % (name, value)
							es.msg("#green", message)

							clear_key(event_var["userid"], steamid)
						else:
							es.tell(event_var["userid"], "#green", error)
					else:
						es.tell(event_var["userid"], "#green", error)
				except ValueError:
					es.tell(event_var["userid"], "#green", error)
			else:
				clear_key(event_var["userid"], steamid)
		elif type == "settings_sprint_length":
			if event_var["text"] != "!cancel":
				error = "Type a value between 1 and 10 in the chat to set the sprint length or type !cancel to cancel."
				try:
					temp_value = float(event_var["text"])
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 10:
							es.set("sm_sprint_length", value)

							line = "->2. %s: %s" % (text("length"), value)
							popup.modline(4, line)

							es.keysetvalue("soccer_mod_settings", "sprint", "length", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(event_var["userid"])
							message = "%s has set the sprint length to %s." % (name, value)
							es.msg("#green", message)

							clear_key(event_var["userid"], steamid)
						else:
							es.tell(event_var["userid"], "#green", error)
					else:
						es.tell(event_var["userid"], "#green", error)
				except ValueError:
					es.tell(event_var["userid"], "#green", error)
			else:
				clear_key(event_var["userid"], steamid)
		elif type == "settings_sprint_reset":
			if event_var["text"] != "!cancel":
				error = "Type a value between 1 and 100 in the chat to set the sprint reset length or type !cancel to cancel."
				try:
					temp_value = float(event_var["text"])
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 100:
							es.set("sm_sprint_reset", value)

							line = "->3. %s: %s" % (text("reset"), value)
							popup.modline(5, line)

							es.keysetvalue("soccer_mod_settings", "sprint", "reset", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(event_var["userid"])
							message = "%s has set the sprint reset length to %s." % (name, value)
							es.msg("#green", message)

							clear_key(event_var["userid"], steamid)
						else:
							es.tell(event_var["userid"], "#green", error)
					else:
						es.tell(event_var["userid"], "#green", error)
				except ValueError:
					es.tell(event_var["userid"], "#green", error)
			else:
				clear_key(event_var["userid"], steamid)

def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_settings_sprint", userid)

def delete_popup():
	if popuplib.exists("sm_popup_admin_settings_sprint"):
		popuplib.delete("sm_popup_admin_settings_sprint")

def unload():
	delete_popup()