import es
import gamethread
import langlib
import popuplib

def load():
	create_popup()

	es.keygroupcreate("soccer_mod_training")

	es.set("sm_training_goals_disabled", 0)

def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/training/popup_admin_training.ini")

	popup = popuplib.create("sm_popup_admin_training")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	line = "->1. %s" % (text("spawn"))
	popup.addline(line)

	line = "->2. %s" % (text("disable_goals"))
	popup.addline(line)

	line = "->3. %s" % (text("enable_goals"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, spawn_ball)
	popup.select(2, disable_goals)
	popup.select(3, enable_goals)
	popup.submenu(4, "sm_popup_admin_training")
	popup.submenu(5, "sm_popup_admin_training")
	popup.submenu(6, "sm_popup_admin_training")
	popup.submenu(7, "sm_popup_admin_training")
	popup.submenu(8, "sm_popup_admin_training")
	popup.submenu(9, "sm_popup_admin")

def es_map_start(event_var):
	es.set("sm_training_goals_disabled", 0)

def round_start(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		delete_keygroup()
		es.keygroupcreate("soccer_mod_training")

		check = es.ServerVar("sm_training_goals_disabled")
		if check == 1:
			remove_trigger()
			gamethread.delayed(0.1, remove_trigger)

def player_disconnect(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		players = es.getUseridList()
		number = 0
		for player in players:
			number += 1
		if number < 1:
			es.set("sm_training_goals_disabled", 0)

def spawn_ball(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "soccer_mod_training", steamid)
	if exists == 0:
		check = es.ServerVar("match")
		if check == 0:
			model = es.ServerVar("sm_training_model_ball")
			cmd = "es_xprop_physics_create %s %s" % (userid, model)
			es.server.queuecmd(cmd)

			check = es.ServerVar("eventscripts_lastgive")
			if check > 0:
				es.keycreate("soccer_mod_training", steamid)
				es.keysetvalue("soccer_mod_training", steamid, "ball_index", check)
				es.tell(userid, "#green", "You have spawned a ball.")
		else:
			es.tell(userid, "#green", "You can not spawn a ball during a match.")
	else:
		ball_index = es.keygetvalue("soccer_mod_training", steamid, "ball_index")
		if ball_index > 0:
			es.remove(ball_index)

		es.keydelete("soccer_mod_training", steamid)

		es.tell(userid, "#green", "The ball has been removed.")

	popuplib.send("sm_popup_admin_training", userid)

def disable_goals(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		check = es.ServerVar("sm_training_goals_disabled")
		if check == 0:
			remove_trigger()
			gamethread.delayed(0.1, remove_trigger)

			es.set("sm_training_goals_disabled", 1)

			name = es.getplayername(userid)
			message = "%s has disabled the goals." % (name)
			es.msg("#green", message)
		else:
			es.tell(userid, "#green", "Goals are already disabled.")
	else:
		es.tell(userid, "#green", "You can not disable the goals during a match.")

	popuplib.send("sm_popup_admin_training", userid)

def remove_trigger():
	entity_index = es.getentityindex("trigger_hurt")
	if entity_index > 0:
		es.remove(entity_index)

def enable_goals(userid, choice, popupid):
	check = es.ServerVar("sm_training_goals_disabled")
	if check == 1:
		cmd = "mp_restartgame 1"
		es.server.queuecmd(cmd)
		es.set("sm_training_goals_disabled", 0)

		name = es.getplayername(userid)
		message = "%s has enabled the goals." % (name)
		es.msg("#green", message)
	else:
		es.tell(userid, "#green", "Goals are already enabled.")

	popuplib.send("sm_popup_admin_training", userid)

def delete_keygroup():
	exists = es.exists("keygroup", "soccer_mod_training")
	if exists == 1:
		es.keygroupdelete("soccer_mod_training")

def delete_popup():
	if popuplib.exists("sm_popup_admin_training"):
		popuplib.delete("sm_popup_admin_training")

def unload():
	delete_keygroup()
	delete_popup()